# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetGcpResult',
    'AwaitableGetGcpResult',
    'get_gcp',
    'get_gcp_output',
]

@pulumi.output_type
class GetGcpResult:
    """
    A collection of values returned by getGcp.
    """
    def __init__(__self__, client_email=None, created_at=None, description=None, id=None, links=None, name=None, org_id=None, owner=None, private_key_id=None, project_id=None, regions=None, tags=None, updated_at=None):
        if client_email and not isinstance(client_email, str):
            raise TypeError("Expected argument 'client_email' to be a str")
        pulumi.set(__self__, "client_email", client_email)
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if links and not isinstance(links, list):
            raise TypeError("Expected argument 'links' to be a list")
        pulumi.set(__self__, "links", links)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)
        if owner and not isinstance(owner, str):
            raise TypeError("Expected argument 'owner' to be a str")
        pulumi.set(__self__, "owner", owner)
        if private_key_id and not isinstance(private_key_id, str):
            raise TypeError("Expected argument 'private_key_id' to be a str")
        pulumi.set(__self__, "private_key_id", private_key_id)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if regions and not isinstance(regions, list):
            raise TypeError("Expected argument 'regions' to be a list")
        pulumi.set(__self__, "regions", regions)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="clientEmail")
    def client_email(self) -> str:
        """
        GCP Client email.
        """
        return pulumi.get(self, "client_email")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Date when the entity was created. The date is in ISO 6801 and UTC.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        A human-friendly description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def links(self) -> Sequence['outputs.GetGcpLinkResult']:
        """
        HATEOAS of the entity.
        """
        return pulumi.get(self, "links")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        """
        The id of the organization this entity belongs to.
        """
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Email of the user that owns the entity.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter(name="privateKeyId")
    def private_key_id(self) -> str:
        """
        GCP Private key ID.
        """
        return pulumi.get(self, "private_key_id")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> str:
        """
        GCP Project ID.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def regions(self) -> Sequence[str]:
        """
        A set of region names that are enabled for this account.
        """
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter
    def tags(self) -> Sequence['outputs.GetGcpTagResult']:
        """
        A set of tag keys and optional values that were set on this resource.
        example:[ { "key" : "vmware", "value": "provider" } ]
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Date when the entity was last updated. The date is ISO 8601 and UTC.
        """
        return pulumi.get(self, "updated_at")


class AwaitableGetGcpResult(GetGcpResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGcpResult(
            client_email=self.client_email,
            created_at=self.created_at,
            description=self.description,
            id=self.id,
            links=self.links,
            name=self.name,
            org_id=self.org_id,
            owner=self.owner,
            private_key_id=self.private_key_id,
            project_id=self.project_id,
            regions=self.regions,
            tags=self.tags,
            updated_at=self.updated_at)


def get_gcp(id: Optional[str] = None,
            name: Optional[str] = None,
            tags: Optional[Sequence[pulumi.InputType['GetGcpTagArgs']]] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGcpResult:
    """
    Provides a VMware vRA cloudaccount.Gcp data source.

    ## Example Usage
    ### S

    **GCP cloud account data source by its id:**

    This is an example of how to create an GCP cloud account resource and read it as a data source using its id.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_gcp(id=var["vra_cloud_account_gcp_id"])
    ```

    **GCP cloud account data source by its name:**

    This is an example of how to read the cloud account data source using its name.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_gcp(name=var["vra_cloud_account_gcp_name"])
    ```


    :param str id: The id of this GCP cloud account.
    :param str name: The name of this GCP cloud account.
    :param Sequence[pulumi.InputType['GetGcpTagArgs']] tags: A set of tag keys and optional values that were set on this resource.
           example:[ { "key" : "vmware", "value": "provider" } ]
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['name'] = name
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vra:cloudaccount/getGcp:getGcp', __args__, opts=opts, typ=GetGcpResult).value

    return AwaitableGetGcpResult(
        client_email=__ret__.client_email,
        created_at=__ret__.created_at,
        description=__ret__.description,
        id=__ret__.id,
        links=__ret__.links,
        name=__ret__.name,
        org_id=__ret__.org_id,
        owner=__ret__.owner,
        private_key_id=__ret__.private_key_id,
        project_id=__ret__.project_id,
        regions=__ret__.regions,
        tags=__ret__.tags,
        updated_at=__ret__.updated_at)


@_utilities.lift_output_func(get_gcp)
def get_gcp_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                   name: Optional[pulumi.Input[Optional[str]]] = None,
                   tags: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetGcpTagArgs']]]]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGcpResult]:
    """
    Provides a VMware vRA cloudaccount.Gcp data source.

    ## Example Usage
    ### S

    **GCP cloud account data source by its id:**

    This is an example of how to create an GCP cloud account resource and read it as a data source using its id.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_gcp(id=var["vra_cloud_account_gcp_id"])
    ```

    **GCP cloud account data source by its name:**

    This is an example of how to read the cloud account data source using its name.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_gcp(name=var["vra_cloud_account_gcp_name"])
    ```


    :param str id: The id of this GCP cloud account.
    :param str name: The name of this GCP cloud account.
    :param Sequence[pulumi.InputType['GetGcpTagArgs']] tags: A set of tag keys and optional values that were set on this resource.
           example:[ { "key" : "vmware", "value": "provider" } ]
    """
    ...
