# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetVmcResult',
    'AwaitableGetVmcResult',
    'get_vmc',
    'get_vmc_output',
]

@pulumi.output_type
class GetVmcResult:
    """
    A collection of values returned by getVmc.
    """
    def __init__(__self__, created_at=None, dc_id=None, description=None, id=None, links=None, name=None, nsx_hostname=None, org_id=None, owner=None, regions=None, sddc_name=None, tags=None, updated_at=None, vcenter_hostname=None, vcenter_username=None):
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if dc_id and not isinstance(dc_id, str):
            raise TypeError("Expected argument 'dc_id' to be a str")
        pulumi.set(__self__, "dc_id", dc_id)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if links and not isinstance(links, list):
            raise TypeError("Expected argument 'links' to be a list")
        pulumi.set(__self__, "links", links)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if nsx_hostname and not isinstance(nsx_hostname, str):
            raise TypeError("Expected argument 'nsx_hostname' to be a str")
        pulumi.set(__self__, "nsx_hostname", nsx_hostname)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)
        if owner and not isinstance(owner, str):
            raise TypeError("Expected argument 'owner' to be a str")
        pulumi.set(__self__, "owner", owner)
        if regions and not isinstance(regions, list):
            raise TypeError("Expected argument 'regions' to be a list")
        pulumi.set(__self__, "regions", regions)
        if sddc_name and not isinstance(sddc_name, str):
            raise TypeError("Expected argument 'sddc_name' to be a str")
        pulumi.set(__self__, "sddc_name", sddc_name)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)
        if vcenter_hostname and not isinstance(vcenter_hostname, str):
            raise TypeError("Expected argument 'vcenter_hostname' to be a str")
        pulumi.set(__self__, "vcenter_hostname", vcenter_hostname)
        if vcenter_username and not isinstance(vcenter_username, str):
            raise TypeError("Expected argument 'vcenter_username' to be a str")
        pulumi.set(__self__, "vcenter_username", vcenter_username)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Date when the entity was created. The date is in ISO 6801 and UTC.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="dcId")
    def dc_id(self) -> str:
        """
        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collector.
        """
        return pulumi.get(self, "dc_id")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        A human-friendly description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def links(self) -> Sequence['outputs.GetVmcLinkResult']:
        """
        HATEOAS of the entity.
        """
        return pulumi.get(self, "links")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nsxHostname")
    def nsx_hostname(self) -> str:
        """
        The IP address of the NSX Manager server in the specified SDDC / FQDN.
        """
        return pulumi.get(self, "nsx_hostname")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        """
        The id of the organization this entity belongs to.
        """
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Email of the user that owns the entity.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def regions(self) -> Sequence[str]:
        """
        A set of region names that are enabled for this account.
        """
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter(name="sddcName")
    def sddc_name(self) -> str:
        """
        Identifier of the on-premise SDDC to be used by this cloud account. Note that NSX-V SDDCs are not supported.
        """
        return pulumi.get(self, "sddc_name")

    @property
    @pulumi.getter
    def tags(self) -> Sequence['outputs.GetVmcTagResult']:
        """
        A set of tag keys and optional values that were set on this resource.
        example:[ { "key" : "vmware", "value": "provider" } ]
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Date when the entity was last updated. The date is ISO 8601 and UTC.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="vcenterHostname")
    def vcenter_hostname(self) -> str:
        """
        The IP address or FQDN of the vCenter Server in the specified SDDC. The cloud proxy belongs on this vCenter.
        """
        return pulumi.get(self, "vcenter_hostname")

    @property
    @pulumi.getter(name="vcenterUsername")
    def vcenter_username(self) -> str:
        """
        vCenter user name for the specified SDDC. The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials.
        """
        return pulumi.get(self, "vcenter_username")


class AwaitableGetVmcResult(GetVmcResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVmcResult(
            created_at=self.created_at,
            dc_id=self.dc_id,
            description=self.description,
            id=self.id,
            links=self.links,
            name=self.name,
            nsx_hostname=self.nsx_hostname,
            org_id=self.org_id,
            owner=self.owner,
            regions=self.regions,
            sddc_name=self.sddc_name,
            tags=self.tags,
            updated_at=self.updated_at,
            vcenter_hostname=self.vcenter_hostname,
            vcenter_username=self.vcenter_username)


def get_vmc(id: Optional[str] = None,
            name: Optional[str] = None,
            tags: Optional[Sequence[pulumi.InputType['GetVmcTagArgs']]] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVmcResult:
    """
    Provides a VMware vRA cloudaccount.Vmc data source.

    ## Example Usage
    ### S

    **VMC cloud account data source by its id:**

    This is an example of how to read the cloud account data source using its id.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_vmc(id=var["vra_cloud_account_vmc_id"])
    ```

    **vmc cloud account data source by its name:**

    This is an example of how to read the cloud account data source using its name.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_vmc(name=var["vra_cloud_account_vmc_name"])
    ```


    :param str id: The id of this vmc cloud account.
    :param str name: The name of this vmc cloud account.
    :param Sequence[pulumi.InputType['GetVmcTagArgs']] tags: A set of tag keys and optional values that were set on this resource.
           example:[ { "key" : "vmware", "value": "provider" } ]
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['name'] = name
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vra:cloudaccount/getVmc:getVmc', __args__, opts=opts, typ=GetVmcResult).value

    return AwaitableGetVmcResult(
        created_at=__ret__.created_at,
        dc_id=__ret__.dc_id,
        description=__ret__.description,
        id=__ret__.id,
        links=__ret__.links,
        name=__ret__.name,
        nsx_hostname=__ret__.nsx_hostname,
        org_id=__ret__.org_id,
        owner=__ret__.owner,
        regions=__ret__.regions,
        sddc_name=__ret__.sddc_name,
        tags=__ret__.tags,
        updated_at=__ret__.updated_at,
        vcenter_hostname=__ret__.vcenter_hostname,
        vcenter_username=__ret__.vcenter_username)


@_utilities.lift_output_func(get_vmc)
def get_vmc_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                   name: Optional[pulumi.Input[Optional[str]]] = None,
                   tags: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetVmcTagArgs']]]]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetVmcResult]:
    """
    Provides a VMware vRA cloudaccount.Vmc data source.

    ## Example Usage
    ### S

    **VMC cloud account data source by its id:**

    This is an example of how to read the cloud account data source using its id.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_vmc(id=var["vra_cloud_account_vmc_id"])
    ```

    **vmc cloud account data source by its name:**

    This is an example of how to read the cloud account data source using its name.

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.cloudaccount.get_vmc(name=var["vra_cloud_account_vmc_name"])
    ```


    :param str id: The id of this vmc cloud account.
    :param str name: The name of this vmc cloud account.
    :param Sequence[pulumi.InputType['GetVmcTagArgs']] tags: A set of tag keys and optional values that were set on this resource.
           example:[ { "key" : "vmware", "value": "provider" } ]
    """
    ...
