# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetStorageAccountAzureResult',
    'AwaitableGetStorageAccountAzureResult',
    'get_storage_account_azure',
    'get_storage_account_azure_output',
]

@pulumi.output_type
class GetStorageAccountAzureResult:
    """
    A collection of values returned by getStorageAccountAzure.
    """
    def __init__(__self__, cloud_account_ids=None, created_at=None, description=None, external_id=None, external_region_id=None, filter=None, id=None, links=None, name=None, org_id=None, owner=None, type=None, updated_at=None):
        if cloud_account_ids and not isinstance(cloud_account_ids, list):
            raise TypeError("Expected argument 'cloud_account_ids' to be a list")
        pulumi.set(__self__, "cloud_account_ids", cloud_account_ids)
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if external_id and not isinstance(external_id, str):
            raise TypeError("Expected argument 'external_id' to be a str")
        pulumi.set(__self__, "external_id", external_id)
        if external_region_id and not isinstance(external_region_id, str):
            raise TypeError("Expected argument 'external_region_id' to be a str")
        pulumi.set(__self__, "external_region_id", external_region_id)
        if filter and not isinstance(filter, str):
            raise TypeError("Expected argument 'filter' to be a str")
        pulumi.set(__self__, "filter", filter)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if links and not isinstance(links, list):
            raise TypeError("Expected argument 'links' to be a list")
        pulumi.set(__self__, "links", links)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)
        if owner and not isinstance(owner, str):
            raise TypeError("Expected argument 'owner' to be a str")
        pulumi.set(__self__, "owner", owner)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="cloudAccountIds")
    def cloud_account_ids(self) -> Sequence[str]:
        """
        Set of ids of the cloud accounts this entity belongs to.
        """
        return pulumi.get(self, "cloud_account_ids")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Date when the entity was created. The date is in ISO 6801 and UTC.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        A human-friendly description of the fabric Azure storage account.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> str:
        """
        External entity Id on the provider side.
        """
        return pulumi.get(self, "external_id")

    @property
    @pulumi.getter(name="externalRegionId")
    def external_region_id(self) -> str:
        """
        The id of the region for which this entity is defined.
        """
        return pulumi.get(self, "external_region_id")

    @property
    @pulumi.getter
    def filter(self) -> Optional[str]:
        return pulumi.get(self, "filter")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def links(self) -> Sequence['outputs.GetStorageAccountAzureLinkResult']:
        """
        HATEOAS of the entity
        """
        return pulumi.get(self, "links")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        A human-friendly name used as an identifier in APIs that support this option.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        """
        The id of the organization this entity belongs to.
        """
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Email of the user that owns the entity.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Indicates the performance tier for the storage type. Premium disks are SSD backed and Standard disks are HDD backed. example: Standard_LRS / Premium_LRS
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Date when the entity was last updated. The date is ISO 8601 and UTC.
        """
        return pulumi.get(self, "updated_at")


class AwaitableGetStorageAccountAzureResult(GetStorageAccountAzureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetStorageAccountAzureResult(
            cloud_account_ids=self.cloud_account_ids,
            created_at=self.created_at,
            description=self.description,
            external_id=self.external_id,
            external_region_id=self.external_region_id,
            filter=self.filter,
            id=self.id,
            links=self.links,
            name=self.name,
            org_id=self.org_id,
            owner=self.owner,
            type=self.type,
            updated_at=self.updated_at)


def get_storage_account_azure(filter: Optional[str] = None,
                              id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetStorageAccountAzureResult:
    """
    ## Example Usage
    ### S
    This is an example of how to lookup fabric Azure storage account.

    **Fabric Azure storage account by Id:**

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.fabric.get_storage_account_azure(id=var["fabric_storage_account_azure_id"])
    ```

    **Fabric Azure storage by filter query:**

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.fabric.get_storage_account_azure(filter=f"name eq '{var['name']}'")
    ```

    A fabric Azure storage account supports the following arguments:


    :param str filter: Search criteria to narrow down the fabric Azure storage accounts. Only one of 'filter' or 'id' must be specified.
    :param str id: The id of the fabric Azure storage account. Only one of 'filter' or 'id' must be specified.
    """
    __args__ = dict()
    __args__['filter'] = filter
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vra:fabric/getStorageAccountAzure:getStorageAccountAzure', __args__, opts=opts, typ=GetStorageAccountAzureResult).value

    return AwaitableGetStorageAccountAzureResult(
        cloud_account_ids=__ret__.cloud_account_ids,
        created_at=__ret__.created_at,
        description=__ret__.description,
        external_id=__ret__.external_id,
        external_region_id=__ret__.external_region_id,
        filter=__ret__.filter,
        id=__ret__.id,
        links=__ret__.links,
        name=__ret__.name,
        org_id=__ret__.org_id,
        owner=__ret__.owner,
        type=__ret__.type,
        updated_at=__ret__.updated_at)


@_utilities.lift_output_func(get_storage_account_azure)
def get_storage_account_azure_output(filter: Optional[pulumi.Input[Optional[str]]] = None,
                                     id: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetStorageAccountAzureResult]:
    """
    ## Example Usage
    ### S
    This is an example of how to lookup fabric Azure storage account.

    **Fabric Azure storage account by Id:**

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.fabric.get_storage_account_azure(id=var["fabric_storage_account_azure_id"])
    ```

    **Fabric Azure storage by filter query:**

    ```python
    import pulumi
    import pulumi_vra as vra

    this = vra.fabric.get_storage_account_azure(filter=f"name eq '{var['name']}'")
    ```

    A fabric Azure storage account supports the following arguments:


    :param str filter: Search criteria to narrow down the fabric Azure storage accounts. Only one of 'filter' or 'id' must be specified.
    :param str id: The id of the fabric Azure storage account. Only one of 'filter' or 'id' must be specified.
    """
    ...
